<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>

	<title>Bootstrap-Flex</title>
</head>
<body>

	<div class="container-fluid text-center">
		<h1>Bootstrap Flex</h1>
		<p>Use the d-flex class to create a flex container and transform direct children into flext items.</p>

		<h2>Centering elements</h2>
		<!-- d-flex - the flext value will change the element into block-level container, elements become inline ; 3 columns since 3 elements (flex item A-C). It will make all the elements become "flexible/in-line". Row - no margin; d-flex with margin, justify-content-center (only for d-flex) -->

		<!-- justify-content-center 0 it will horizontallly center all child elements and it will only be accessible if the display value is flex. -->

		<!-- align-items-center class will vertically center all the child elements. -->

		<!-- flex-column - will display elements on top of each other. -->

		<!-- flex-column-reverse will reverse the arrangement on top of each other. -->
		<div style="height: 500px;" class="bg-dark p-3 d-flex justify-content-center align-items-center flex-column-reverse">  
			<div class="h-25 p-3 bg-success col-2">Flex Item A</div>
			<div class="h-25 p-3 bg-warning col-2">Flex Item B</div>
			<div class="h-25 p-3 bg-danger col-2">Flex Item C</div>
		</div>

		<h2>Flex Row</h2>
		<!-- flex-row - is d-flex by default, changes how the elements display horizontally.  -->
		<!-- order-# still applicable. -->
		<div class="bg-dark p-3 d-flex flex-row">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row Reverse</h2>
		<div class="bg-dark p-3 d-flex flex-row-reverse">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>
		
		<h2>Creating Space Between</h2>
		<!-- d-md-flex class will apple flex values to the display property on a medium size screen and higher. -->

		<!-- justify-content-around - gives spaces / distributes the spaces in between the inline. -->
		<div class="p-3 bg-dark d-md-flex justify-content-around">
			<div class="p-3 bg-success col-md-2">Flex Item A</div>
			<div class="p-3 bg-warning col-md-2">Flex Item B</div>
			<div class="p-3 bg-danger col-md-2">Flex Item C</div>
		</div>

		<h2>Flex box with margin</h2>
		<!-- mr-auto - will occupy the remaining width of its parent container pushing all the other elements inline.  -->
		<div class="bg-dark p-3 d-flex">
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
			<div class="p-3 bg-primary">Flex Item D</div>
		</div>

		<h2>Nested Flex Elements</h2>
		<!-- d-flex only applies to the child element, add more if needed. -->
		<div class="bg-dark p-3 d-flex">
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
				<div class="d-flex justify-content-between w-50">
					<div class="p-3 bg-warning">Flex Item B</div>
					<div class="p-3 bg-danger">Flext Item C</div>
					<div class="p-3 bg-primary">Flext Item D</div>
				</div>
		</div>
	</div>





	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
</body>
</html>